# version abstraction
# Manuel Amador (Rudd-O) - written on 2005-11-28
# under the GPL

class Version:
	major = 0
	minor = 0
	micro = 0
	def __init__(self,version_string):
		splitted = version_string.split(".",2)
		try:
			major = int(splitted[0])
			try: minor = int(splitted[1])
			except IndexError: minor = 0
			try: micro = int(splitted[2])
			except IndexError: micro = 0
		except ValueError: raise ValueError, "invalid version string for Version(): %s"%version_string
		self.major = major
		self.minor = minor
		self.micro = micro
		self.version_string = version_string
		
	def __cmp__(self,other):
		for versiontuple in [ (self.major,other.major),(self.minor,other.minor),(self.micro,other.micro) ]:
			mine,others = versiontuple
			if mine > others: return 1
			if mine < others: return -1
		return 0

__all__ = ["Version"]